#comments-start
UDF_Log_gui Ecrit par timmalos (tim@malossane.fr)
Cet UDF a t ecrit afin de faciliter la gestion des logs par vos programmes. Si vous souhaitez avertir l'utilisateur
d'une quelconque action, cet UDF est fait pour vous.

Il a t concu pour etre utilis tres facilement.
Voyez l'exemple fourni (sample.au3) pour comprendre son fonctionnement.
Une aide plus dtaille sera crite a l'occasion de futures mises a jour.

Todo List:
_Autoriser l'utilisation d'autres icones, soit par des DLL soit par une icone mise dans le dossier du script
_Ameliorer la gestion d'erreur et des retours tres sommaire.
_Mettre en place un systeme de sauvegarde du log dans un fichier.
_Utiliser l'Array_Modifier_Gui deja prsent dans Exemples (autoitscript.fr) pour autoriser une multitude d'action lors de la sauvegarde
#comments-end
#AutoIt3Wrapper_Au3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6
#include-once
#include <GuiConstantsEx.au3>
#include <GuiListView.au3>
#include <GuiImageList.au3>
#include <GuiStatusBar.au3>
#include <WinAPI.au3>
#include <WindowsConstants.au3>
#include <Date.au3>
#include <Array.au3>

Global $LL_opts
;If Not GUISetOnEvent($GUI_EVENT_CLOSE, "__SpecialEvents") Then $LL_opts = 0
Opt('GUIOnEventMode', 1)
Opt('GUIEventOptions', 0)


Func _Log_gui_show_hide($LL_flag)
	If Not IsDeclared("LL_GUI") Then SetError(1, 0, 0)
	GUISetState($LL_flag, $LL_GUI)
EndFunc   ;==>_Log_gui_show_hide

Func _Log_gui_set_percent($LL_number_flag)
	If Not IsDeclared("LL_GUI") Then SetError(1, 0, 0)
	_GUICtrlStatusBar_SetText($LL_hStatus, "Progression ... " & $LL_number_flag & "%", 0)
EndFunc   ;==>_Log_gui_set_percent

Func _Log_gui_set_status_bar($LL_texte1)
	If Not IsDeclared("LL_GUI") Then SetError(1, 0, 0)
	_GUICtrlStatusBar_SetText($LL_hStatus, $LL_texte1, 1)
EndFunc   ;==>_Log_gui_set_status_bar

Func _Log_Gui_Add($LL_Texte, $LL_icon)
	If Not IsDeclared("LL_GUI") Then SetError(1, 0, 0)
	;Icon: 0 = OK, 1 = Attention, 2 = ERREUR, 3 = Interrogation
	;_GUICtrlListView_BeginUpdate($LL_hListView)
	_GUICtrlListView_AddItem($LL_hListView, $LL_Texte, Number($LL_icon))
	If $LL_title_group1 Then _GUICtrlListView_SetItemGroupID($LL_hListView, Number(_GUICtrlListView_GetItemCount($LL_hListView)) - 1, 1)
	;_GUICtrlListView_EndUpdate($LL_hListView)
EndFunc   ;==>_Log_Gui_Add

Func _Log_Gui_Create($LL_title = "LOG BY TIM", $LL_weight = 800, $LL_height = 500, $LL_left = 0, $LL_right = 0, $LL_top = 0, $LL_sFilePath = "\fond.jpg", $LL_title_group = 0, $LL_hauteur_ligne = 24)
	Global $LL_title_group1 = Number($LL_title_group)
	Select
		Case Not IsString($LL_title)
			SetError(2, 0, 0)
		Case Not IsNumber($LL_weight) Or Not IsNumber($LL_height) Or Not IsNumber($LL_top) Or Not IsNumber($LL_left)
			SetError(3, 0, 0)
		Case $LL_sFilePath <> 0
			If Not IsString($LL_sFilePath) Then SetError(4, 0, 0)
			If Not FileExists($LL_sFilePath) Then SetError(4, 1, 0)

		Case $LL_hauteur_ligne <> 24
			$LL_hauteur_ligne = Number($LL_hauteur_ligne)
			If $LL_hauteur_ligne = 0 Then SetError(5, 0, 0)
			If $LL_hauteur_ligne < 10 Then SetError(5, 1, 0)
		Case $LL_title_group <> 0
			If Not IsBool($LL_title_group) Then SetError(6, 0, 0)
	EndSelect


	Global $LL_GUI
	$LL_GUI = GUICreate($LL_title, $LL_weight, $LL_height, $LL_left, $LL_top, BitOR($GUI_SS_DEFAULT_GUI, $WS_OVERLAPPEDWINDOW))
	GUISetOnEvent($GUI_EVENT_CLOSE, "__SpecialEvents")
	GUISetOnEvent($GUI_EVENT_MINIMIZE, "__SpecialEvents")
	GUISetOnEvent($GUI_EVENT_RESTORE, "__SpecialEvents")

	#Region Create_ListView
	Global $LL_hListView
	Local $LL_hImage
	;=========================================================================================================
	$LL_hListView = _GUICtrlListView_Create($LL_GUI, "", 1, 1, $LL_weight - 2, $LL_height - 26, $LVS_NOCOLUMNHEADER + $LVS_REport, -1, True) ; Last option Calls CoInitializeEx
	GUICtrlSetResizing($LL_hListView, $GUI_DOCKBORDERS)
	GUIRegisterMsg($WM_SIZE, "WM_SIZE")

	;=========================================================================================================
	If $LL_sFilePath <> 0 Then _GUICtrlListView_SetBkImage($LL_hListView, $LL_sFilePath)
	_GUICtrlListView_SetExtendedListViewStyle($LL_hListView, BitOR($LVS_EX_FULLROWSELECT, $LVS_EX_DOUBLEBUFFER))

	; Build groups
	If $LL_title_group Then
		_GUICtrlListView_EnableGroupView($LL_hListView)
		_GUICtrlListView_InsertGroup($LL_hListView, -1, 1, "Aperu des erreurs")
	EndIf

	; Load images
	$LL_hImage = _GUIImageList_Create($LL_hauteur_ligne, $LL_hauteur_ligne, 5, 1)
	_GUIImageList_AddIcon($LL_hImage, @SystemDir & "\shell32.dll", -246, 1); Lancement
	_GUIImageList_AddIcon($LL_hImage, @SystemDir & "\shell32.dll", -161, 1) ; Attention
	_GUIImageList_AddIcon($LL_hImage, @SystemDir & "\shell32.dll", -240, 1) ; Erreur
	_GUIImageList_AddIcon($LL_hImage, @SystemDir & "\Shell32.dll", -324, 1) ; Interrogation
	_GUIImageList_AddIcon($LL_hImage, @SystemDir & "\shell32.dll", -253, 1) ; Ok
	_GUIImageList_AddIcon($LL_hImage, @SystemDir & "\shell32.dll", -23, 1) ; Recherche
	_GUIImageList_AddIcon($LL_hImage, @SystemDir & "\shell32.dll", -1001, 1) ;Information
	_GUICtrlListView_SetImageList($LL_hListView, $LL_hImage, 1)

	; Add columns
	_GUICtrlListView_InsertColumn($LL_hListView, 0, "Column 1", 798)
	#EndRegion Create_ListView

	AdlibRegister("__Log_Hour", 200)
	#Region Create StatusBar
	Global $LL_hStatus
	Local $LL_aParts[3] = [$LL_weight / 6, $LL_weight / 1.3, $LL_weight / 4]
	$LL_hStatus = _GUICtrlStatusBar_Create($LL_GUI)
	_GUICtrlStatusBar_SetParts($LL_hStatus, $LL_aParts)
	_GUICtrlStatusBar_SetText($LL_hStatus, "Progression ... 0%", 0)
	_GUICtrlStatusBar_SetText($LL_hStatus, "Opration 1 en cours...", 1)
	_GUICtrlStatusBar_SetText($LL_hStatus, _NowTime() & " Script by Timmalos", 2)
	#EndRegion Create StatusBar

	;If $LL_opts = 0 Then Opt('GUIOnEventMode', 0)
EndFunc   ;==>_Log_Gui_Create

Func _Log_Gui_Close()
	DllCall('ole32.dll', 'long', 'CoUinitialize') ; Must call for each CoInitializeEx call made
	AdlibUnRegister("__Log_Hour")
	GUIDelete($LL_GUI)
EndFunc   ;==>_Log_Gui_Close

Func WM_SIZE($hWnd, $iMsg, $iwParam, $ilParam)
	_GUICtrlStatusBar_Resize($LL_hStatus)
	Return $GUI_RUNDEFMSG
EndFunc   ;==>WM_SIZE
Func __Write($texte)
	ConsoleWrite($texte)
EndFunc   ;==>__Write
Func __SpecialEvents()
	Select
		Case @GUI_CtrlId = $GUI_EVENT_CLOSE
			;MsgBox(0, "Close Pressed", "ID=" & @GUI_CtrlId & " WinHandle=" & @GUI_WinHandle)
			_Log_gui_show_hide(@SW_HIDE)

		Case @GUI_CtrlId = $GUI_EVENT_MINIMIZE
			_Log_gui_show_hide(@SW_MINIMIZE)
		Case @GUI_CtrlId = $GUI_EVENT_MAXIMIZE
			_Log_gui_show_hide(@SW_MINIMIZE)
		Case @GUI_CtrlId = $GUI_EVENT_RESTORE
			_Log_gui_show_hide(@SW_RESTORE)

	EndSelect
EndFunc   ;==>__SpecialEvents

Func __Log_Hour()
	_GUICtrlStatusBar_SetText($LL_hStatus, _NowTime() & " Script by Timmalos", 2)
EndFunc   ;==>__Log_Hour
